<template lang="pug">
Box(:title="$t('page.profile.operations.input.title')")
  Table(:columns="columns", :data="operations")
    template(v-slot:date="{ item }") {{ dayjs(item.date).format('DD/MM/YYYY, HH:mm') }}
    template(v-slot:sum="{ item }")
      p.has-text-success.has-text-weight-bold +{{ item.sum }} IBT
</template>

<script lang="ts">
import dayjs from "dayjs";
import Vue from "vue";
import Component from "vue-class-component";
import { VModel, Prop, Watch } from "vue-property-decorator";
import { BigNumber } from "bignumber.js";
import { UserModule } from "./../../store/module/UserModule";
import { Web3Module } from "./../../store/module/Web3Module";
import { Contract } from "web3-eth-contract";
import { PoolModule } from "../../store/module/PoolModule";
import { Stake } from "../../store/module/sharedTypes";
import Web3 from "web3";

export type Operation = {
  date: Date;
  sum: string;
};

@Component({
  components: {
    Box: () => import("../Box.vue"),
    Table: () => import("../Table.vue"),
  },
})
export default class Inputs extends Vue {
  dayjs = dayjs;

  operations: Operation[] = [];

  get columns() {
    return [
      {
        field: "date",
        label: this.$t("page.profile.operations.input.date"),
      },
      {
        field: "sum",
        label: this.$t("page.profile.operations.sum"),
      },
    ];
  }

  get account() {
    return this.$store.getters["Web3Module/account"];
  }

  get user(): UserModule.User {
    return this.$store.getters["UserModule/user"];
  }

  get memePool(): PoolModule.Pool {
    return this.$store.getters["PoolModule/memePool"];
  }

  @Watch("user")
  onUserChange() {
    this.load();
  }

  @Watch("memePool")
  onPoolChange() {
    this.load();
  }

  async load() {
    if (!this.user?.address) return;
    if (this.memePool.id === 0) return;
    this.operations.splice(0);

    this.user?.stakes
      ?.filter((stake) => stake.poolId === this.memePool.id)
      .sort((a, b) => {
        return (
          new Date(a.createdAt).getTime() - new Date(b.createdAt).getTime()
        );
      })
      .map((stake) => {
        this.operations.push({
          date: dayjs(stake.expiresIn).toDate(),
          sum: new BigNumber(stake.body).dividedBy(10 ** 18).toString(),
        });
      });
  }

  async mounted() {
    this.load();
  }
}
</script>